#         Portable Batch System (PBS) Software License
# 
# Copyright (c) 1999, MRJ Technology Solutions.
# All rights reserved.
# 
# Acknowledgment: The Portable Batch System Software was originally developed
# as a joint project between the Numerical Aerospace Simulation (NAS) Systems
# Division of NASA Ames Research Center and the National Energy Research
# Supercomputer Center (NERSC) of Lawrence Livermore National Laboratory.
# 
# Redistribution of the Portable Batch System Software and use in source
# and binary forms, with or without modification, are permitted provided
# that the following conditions are met:
# 
# - Redistributions of source code must retain the above copyright and
#   acknowledgment notices, this list of conditions and the following
#   disclaimer.
# 
# - Redistributions in binary form must reproduce the above copyright and 
#   acknowledgment notices, this list of conditions and the following
#   disclaimer in the documentation and/or other materials provided with the
#   distribution.
# 
# - All advertising materials mentioning features or use of this software must
#   display the following acknowledgment:
# 
#   This product includes software developed by NASA Ames Research Center,
#   Lawrence Livermore National Laboratory, and MRJ Technology Solutions.
# 
#         DISCLAIMER OF WARRANTY
# 
# THIS SOFTWARE IS PROVIDED BY MRJ TECHNOLOGY SOLUTIONS ("MRJ") "AS IS" WITHOUT 
# WARRANTY OF ANY KIND, AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING,
# BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS
# FOR A PARTICULAR PURPOSE, AND NON-INFRINGEMENT ARE EXPRESSLY DISCLAIMED.
# 
# IN NO EVENT, UNLESS REQUIRED BY APPLICABLE LAW, SHALL MRJ, NASA, NOR
# THE U.S. GOVERNMENT BE LIABLE FOR ANY DIRECT DAMAGES WHATSOEVER,
# NOR ANY INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
# CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
# OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE
# USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
# 
# This license will be governed by the laws of the Commonwealth of Virginia,
# without reference to its choice of law rules.
################################################################################
# priority: defines the layout and functions of the select priority criteria
#       dialog box.
proc priority {} {
  global LABELFONT priorityDialogBox activeWindow selv

  busy_cursor
## Bring up the standard Dialog box ##
  set priorityDialogBox ".priority"
  set dbox [popupDialogBox $priorityDialogBox "Select Priority Criteria" 1 "" "" 1]
  set activeWindow($priorityDialogBox) 1
  set dbox_top    [lindex $dbox 0]
  set dbox_bottom [lindex $dbox 1]

## BOTTOM PART ##
  set cmdButtons \
  [buildCmdButtons $dbox_bottom \
    {{{ok ok} {help help}}} x 2m 18 3]

  set cmdFrame     [lindex $cmdButtons 0]
  set cmdOk        [lindex $cmdButtons 1]
  set cmdHelp      [lindex $cmdButtons 2]

  $cmdHelp configure -command {xpbs_help select.priority $priorityDialogBox}

  $cmdOk configure -command {
    set operator [oper $selv(priority_op)]
    if { [string compare $operator ""] == 0 } {
      popupInfoBox $priorityDialogBox "Please specify the operator."
      return
    }
    switch -exact -- $selv(priority_option) {
      priority {
         if {[string compare $selv(priority_val) ""] == 0} {
	   popupInfoBox $priorityDialogBox "Please select a priority value."
	   return
	 } 
	 set selv(priority) "Priority: [oper $selv(priority_op)]$selv(priority_val)"
       }
      ANY  { set selv(priority) "Priority: -ANY-" }
    }
    destroy $priorityDialogBox
  }

## TOP PART ##
  frame $dbox_top.header -height 10m -width 10m
  frame $dbox_top.footer -height 10m -width 10m

  frame $dbox_top.c

  frame $dbox_top.c.op
  frame $dbox_top.c.val
  frame $dbox_top.c.val.priority
  frame $dbox_top.c.dummy -relief groove -borderwidth 3
  


  set spin [buildSpinbox $dbox_top.c.op 2 [list = != >= > <= <] selv \
		priority_op "" "left" =]
  set priorityOpFrame [lindex $spin 0]
  set selv(priorityOpEntry) [lindex $spin 1]
  global vlist.$selv(priorityOpEntry) vlist.selv.priority_op

  register_default_action $selv(priorityOpEntry) $cmdOk

  set spinBox [buildSpinbox $dbox_top.c.val.priority 5 -1024-1023 selv \
		priority_val "" "" 0]
  set priorityValFrame  [lindex $spinBox 0]
  set selv(priorityValEntry)  [lindex $spinBox 1]
  set selv(priorityValScroll) [lindex $spinBox 2]
  set selv(priorityValLabel)  [lindex $spinBox 3]

  register_default_action $selv(priorityValEntry) $cmdOk

  set radioList [list   [concat  priority \"value\" $priorityValFrame] \
	                  {a "ANY"} ]
  set rbox [buildRadioboxes $dbox_top.c.val [list $radioList] \
	                    column 0 ""]
  set rboxFrame    [lindex $rbox 0]
  set rboxPriority [lindex $rbox 1]
  set rboxANY      [lindex $rbox 2]

  $rboxPriority configure -variable selv(priority_option) -value priority -command {
     enable_spinbox $selv(priorityValEntry) $selv(priorityValScroll) \
		    $selv(priorityValLabel)
     set vlist.$selv(priorityOpEntry) [list = != >= > <= <]
     set vlist.selv.priority_op [list = != >= > <= <]
     }
  $rboxANY configure   -variable selv(priority_option) -value ANY -command {
     disable_spinbox $selv(priorityValEntry) $selv(priorityValScroll) \
		     $selv(priorityValLabel)
     set vlist.$selv(priorityOpEntry) [list =]
     set selv(priority_op) "="
     set vlist.selv.priority_op "="
     }

## PACK the FRAMES
  label $dbox_top.c.l -text "Priority" -font $LABELFONT
  pack $rboxFrame -in $dbox_top.c.dummy -padx 3 -pady 3
  raise $rboxFrame $dbox_top.c.dummy
  pack $dbox_top.c.l $priorityOpFrame $dbox_top.c.dummy -side left -anchor nw \
		     -padx 5 
  pack $priorityOpFrame $rboxFrame -side left -anchor nw
  pack $dbox_top.header $dbox_top.c $dbox_top.footer -padx 5m

  set priority_arg [lindex $selv(priority) 1]
  switch -regexp -- $priority_arg {
    "-ANY-"  {$rboxANY invoke}
    default  {$rboxPriority invoke}
  }

  register_default_action $priorityDialogBox $cmdOk
  tkwait visibility $priorityDialogBox
  remove_busy_cursor
  catch {tkwait window $priorityDialogBox}
  set activeWindow($priorityDialogBox) 0
}
